Leetcode -- The Skyline Problem

A city's skyline is the outer contour of the silhouette formed by all the buildings in that city when viewed from a distance. Now suppose you are given the locations and height of all the buildings as shown on a cityscape photo (Figure A), write a program to output the skyline formed by these buildings collectively (Figure B).

Buildings  Skyline Contour

The geometric information of each building is represented by a triplet of integers [Li, Ri, Hi], where Li and Ri are the x coordinates of the left and right edge of the ith building, respectively, and Hi is its height. It is guaranteed that 0 ≤ Li, Ri ≤ INT_MAX0 < Hi ≤ INT_MAX, and Ri - Li > 0. You may assume all buildings are perfect rectangles grounded on an absolutely flat surface at height 0.

For instance, the dimensions of all buildings in Figure A are recorded as: [ [2 9 10], [3 7 15], [5 12 12], [15 20 10], [19 24 8] ] .

The output is a list of "key points" (red dots in Figure B) in the format of [ [x1,y1], [x2, y2], [x3, y3], ... ] that uniquely defines a skyline. A key point is the left endpoint of a horizontal line segment. Note that the last key point, where the rightmost building ends, is merely used to mark the termination of the skyline, and always has zero height. Also, the ground in between any two adjacent buildings should be considered part of the skyline contour.

For instance, the skyline in Figure B should be represented as:[ [2 10], [3 15], [7 12], [12 0], [15 10], [20 8], [24, 0] ].

Notes:

  • The number of buildings in any input list is guaranteed to be in the range [0, 10000].
  • The input list is already sorted in ascending order by the left x position Li.
  • The output list must be sorted by the x position.
  • There must be no consecutive horizontal lines of equal height in the output skyline. For instance, [...[2 3], [4 5], [7 5], [11 5], [12 7]...] is not acceptable; the three lines of height 5 should be merged into one in the final output as such: [...[2 3], [4 5], [12 7], ...]
分析:
1. 直观上考虑,这道题实际上就是在取各个分段的最大高度,而需要记录的拐点只可能出现在各个建筑的左右边界处。
2. 我们用一个最大堆来保存当前各个建筑的高度,则在遇到左边界的时候,应该将这个高度插入到最大堆,而遇到右边界的时候,说明某一段高度终止了,应该将这一段高度删除。
3. 每次执行完第2步中的过程,最大堆的堆顶都可能发生变化,而发生变化的坐标就是需要记录的结果。因此还需要设置一个变量保存之前得到的高度,以此验证高度是不是发生了变化。
4. 一些实现的细节:首先这个题目不适合采用priority_queue,因此队列不支持随机的删除。另外也不能用普通的set,因为set会去重。因此比较合适的方案是采用multiset。在删除multiset中的元素时需要注意采用迭代器版本(而非直接对键值删除,因为这会删除所有等于这个键值的记录)。
class Solution {
public:
    vector<pair<int, int>> getSkyline(vector<vector<int>>& buildings) {
        vector<pair<int,int>> ht;
        for(auto &b:buildings)
        {
            ht.push_back({b[0],-b[2]});
            ht.push_back({b[1],b[2]});
        }
        sort(ht.begin(),ht.end());
        multiset<int> heap;
        heap.insert(0);
        vector<pair<int,int>> res;
        int pre=0,cur=0;
        for(auto &h:ht)
        {
            if(h.second<0) heap.insert(-h.second);
            else heap.erase(heap.find(h.second));//only remove the first one
            cur=*heap.rbegin();
            if(pre!=cur)
            {
                res.push_back({h.first,cur});
                pre = cur;
            }
        }
        return res;
    }
};


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值